<?php
session_start();
if (!isset($_SESSION['email'])) {
    header('Location: login.php');
	return;
}
?>
<form role="form" id="add_log_form">

		<input type="hidden" id="logId">
		<input type="hidden" id="rec_type" name="rec_type" value="0">
		
        <div class="form-group">
            <label>Date</label> <span class="mandatory">*</span>
			<input class="mall-input span2 form-control" size="16" type="text" id="log_date">
		</div>
		
        <div class="form-group">
            <label>Odometer (<?= $_SESSION["distance_unit"] ?>) <span class="mandatory">*</span></label>
            <input class="small-input form-control" id="odo" name="odo" type="number"> 
        </div>

        <div class="form-group">
            <label>Quantity (<?= $_SESSION["volume_unit"] ?>) <span class="mandatory">*</span></label>
            <input class="small-input form-control update-cost" id="qty" name="qty" type="number"> 
        </div>
		
		
		<div class="form-group">
            <div class="checkbox">
                <label>
                    <input type="checkbox" value="" id="pfill">Partial Tank
                </label>
            </div>
        </div>
				
		<div class="form-group">
            <div class="checkbox">
                <label>
                    <input type="checkbox" value="" id="mfill">Missed Previous Fill Up
                </label>
            </div>
        </div>
		
        <div class="form-group">
            <label>Price / <?= $_SESSION["volume_unit"] ?> (<?= $_SESSION["currency"] ?>) </label>
            <input id="price" class="form-control update-cost" name="price" type="number">
        </div>
		
        <div class="form-group">
            <label>Total Cost (<?= $_SESSION["currency"] ?>)</label>
            <input id="cost" class="form-control update-cost" name="cost" type="number">
        </div>
						
        <div class="form-group">
            <label>Octane</label>
            <input id="octane" name="octane" class="small-input form-control" type="number">
        </div>

        <div class="form-group">
            <label>Fuel Brand</label>
            <input id="fuel_brand" name="fuelBrand" class="small-input form-control">
        </div>

        <div class="form-group">
            <label>Filling Station</label>
            <input id="filling_station" name="fillStation" class="form-control">
        </div>
		
        <div class="form-group">
            <label>Notes</label>
            <textarea class="form-control" id="notes" name="notes" rows="3"></textarea>
        </div>

	    <div class="form-group">
	        <label>Receipt</label>
	        <input id="img_file" type="file" name="img_file">
	    </div>
		
		<div class="form-group" id="current_receipt" style="display:none">
            <label>Current Receipt</label><br />
            <a id="current_receipt_link" href="" target="_new"><img width="100px" height="100px" id="current_receipt_image" class="thumbnail" src=""></img></a>
        </div>

    </form>
		
		