
var FUELBUDDY_INDEX_URL = "/DatabaseScriptsTempOrig/adixit/index.php#dashboard";
var FUELBUDDY_CHECKLOGIN_URL = "/DatabaseScriptsTempOrig/adixit/checklogin.php";

function onSigninFailure(error) {
  console.log(error);
}
function renderButton() {
  // If the user is signed in, first sign them out and then load the signin button
	gapi.load('auth2', function() {
		gapi.auth2.init().then(function() {
			var auth2 = gapi.auth2.getAuthInstance();
			auth2.signOut().then(function () {
			    gapi.signin2.render('signin-button', {
			      'scope': 'profile email',
			      'width': 150,
			      'height': 30,
			      'longtitle': true,
			      'theme': 'light',
			      'onsuccess': onSigninSuccess,
			      'onfailure': onSigninFailure,
			    });
				
			});
		});
		
	});
}

function onSigninFailure() {
	alert("Error in login. Please try again.");
	$("#loading").hide();
	$("#signin-button").show();
}

function onSigninSuccess(googleUser) {
  // Useful data for your client-side scripts:
  var profile = googleUser.getBasicProfile();

  // The ID token you need to pass to your backend:
  var id_token = googleUser.getAuthResponse().id_token;
  console.log("ID Token: " + id_token);
$("#loading").show();
$("#signin-button").hide();

$.post(FUELBUDDY_CHECKLOGIN_URL,
    { "id_token": id_token},
	function(response) {
		console.log("Auth response: " + JSON.stringify(response));
		if (response['status'] == 'success') {
			location.href = FUELBUDDY_INDEX_URL;
		} else if (response['status'] == 'nobeta') {
			$("#nobeta-modal").modal('show');
		} else {
			alert("Error in login. Please try again.");
			$("#loading").hide();
			$("#signin-button").show();
		}
	},
	"json");
};
