<?php
if (php_sapi_name() == 'cli-server' || $_GET["debug"] == "yes") {
	// continue
} else {
	header('Location: /');
	return;
} 
?>


<html lang="en">
<head>
	<meta name="google-signin-scope" content="email">
	<meta name="google-signin-client_id" content="336428349177-ltd2t026eo1b9bvu9o8ic8ud0d5a0mml.apps.googleusercontent.com">
	<!-- Bootstrap Core CSS -->
	<link href="css/bootstrap.min.css" rel="stylesheet">
	<!-- Custom Fonts -->
	<link href="font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">
	<!-- jQuery -->
	<script src="js/jquery.js"></script>
	<!-- Auth -->
	<script src="js/auth.js"></script>
</head>
<body>
	
	<!-- Nobeta Modal -->
	<div class="modal fade" id="nobeta-modal" tabindex="-1" role="dialog">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
					<h4 class="modal-title"><span id="add_modal_title">Access Denied</span></h4>
				</div>
				<div class="modal-body" id="add_modal_body">	
					To access your data here, you need to sign in from the app first (Main menu > Sign In).
					Please <a href="http://fuelbuddy-app.com/#contact">contact us</a> if you need further assistance.
				</div>
			</div>
		</div>
	</div>
	
	<div class="col-lg-4 col-md-4" style="padding-top:50px; padding-left: 50px">
		<div class="panel panel-default">
			<div class="panel-heading" style="background:#6399ad">
				<h3 class="panel-title">
					<img src="http://fuelbuddy-app.com/images/logo.png" />
					<span style="padding-left: 5px;">
						<sup>
							<small>
								<span style="color: #fff; font-weight: bold; font-family: 'Arial'">BETA</span>
							</small>
						</sup>
					</span>
				</h3>
			</div>
			<div class="panel-body">
				<div id="welcome-message">
					Welcome to Fuel Buddy. Please sign in using your Google account.
					<br />
					<br />
				</div>
				<div id="loading" style="display:none">
					<i class="fa fa-spinner fa-spin" aria-hidden="true"></i>  Loading ...
					<br />
					<br />
				</div>
				  

				<div id="signin-button" data-theme="dark"></div>
				<div id="failure" class="alert alert-danger" role="alert" style="display:none">
					Error in login. Please try again.
				</div>
				<div id="nobeta" class="alert alert-danger" role="alert" style="display:none; margin: 10px;">
					You do not have access to the Fuel Buddy website. Please <a href="http://fuelbuddy-app.com/#contact">contact us</a> if
					you wish to join the beta program.
				</div>
			</div>
		</div>
	</div>
    
    
	<script src="https://apis.google.com/js/platform.js?onload=renderButton" async defer></script>
		
</body>
</html>
