<?php
session_start();
ini_set('display_errors', 'On');
error_reporting(E_ERROR);

// include db config class
require_once __DIR__ . '/db_config.php';

$chartQueries = array(
	"avg-fuel-efficiency" => array(" date, consumption from LOG_TABLE where consumption is not null and consumption > 0 and type = 0 ",  " order by date  "),
	"distance-between-fillups" => array( " date, dist from LOG_TABLE where dist is not null and dist > 0 and type = 0 ", " order by date"),
	"avg-price-per-volume" => array( " date, round(cost/qty) as cost from LOG_TABLE where cost is not null and cost > 0 and qty is not null and qty > 0 and type = 0 ", " order by date"),
	
	
	"fill-ups-per-month" => array("  date, count(*) as fillups from LOG_TABLE where type = 0 ",  " group by month year order by date  "),
	"fuel-cost-per-distance" => array("  _id, cost, dist, partial_fill, date from LOG_TABLE where cost > 0 and dist > 0 and consumption > 0 and type = 0 ", "order by odo asc"),
	
	"trip-dist-by-type" => array(" SUM(dist) as dist , service_type as type from LOG_TABLE WHERE type = 3 ", " group by service_type order by date "),
	"trip-tax-deduction-by-type" => array(" SUM(cost) as cost , service_type as type from LOG_TABLE WHERE type = 3 ", " group by service_type order by date ")
		
		
		
);

function getChartData($queryFragments) {
	$conn = mysqli_connect(DB_SERVER,DB_USER,DB_PASSWORD,DB_DATABASE);
	
	$dateClause = "";
	if (isset($_GET["startDate"]) && isset($_GET["endDate"])) {
		$dateClause = " AND date >= ".$_GET["startDate"]." AND date < ".$_GET["endDate"]." ";
	}
	
	$userAndVehicleClause = " VEHID = '".$_GET["vehid"]."' AND USER_ID = (SELECT USER_ID FROM USER_ID WHERE EMAIL = '".$_SESSION['email']."') ".$dateClause;
	
	$query = "SELECT ".$queryFragments[0]." AND ".$userAndVehicleClause." ".$queryFragments[1];
	error_log ("Running chart query: ".$query);
		
	$sth = mysqli_query($conn, $query);
	$rows = array();
	while($r = mysqli_fetch_assoc($sth)) {
	    $rows[] = $r;
	}
	print json_encode($rows);
}
	
getChartData($chartQueries[$_GET["chart-name"]]);
?>


